﻿define([// Dojo    
        "dojo",
        "dojo/_base/declare",
        //CMS    
        "epi/_Module",
        "epi/dependency",
    "epi/routes",
    "epi-cms/command/EditImage",
    "epi-cms/content-approval/command/EditApprovalDefinition"
    ],
    function (
        // Dojo    
        dojo,
        declare,
        //CMS  
        _Module,
        dependency,
        routes,
        EditImage,
        EditApprovalDefinition
	) {
        return declare("digizuite.DigizuiteInitializeModule", [_Module], {
            // summary: Module initializer for the default module.      
            initialize: function () {
                this.inherited(arguments);
                var registry = this.resolveDependency("epi.storeregistry");
                //Register the store           
                registry.create("digizuite.widgetsearch", this._getRestPath("widgetsearch"));
                registry.create("digizuite.translation", this._getRestPath("translation"));
                registry.create("digi.cms.content.light", routes.getRestPath({ moduleArea: "cms", storeName: "contentstructure" }), { idProperty: "contentLink"});

                //Remove command to open in Image Editor for Digizuite Images
                var original = EditImage.prototype._onModelChange;
                EditImage.prototype._onModelChange = function () {
                    original.apply(this, arguments);
                    var target = this._getSingleSelectionData();
                    if (target) {
                        if (target.contentLink.endsWith('__DIGI')) {
                            this.set("isAvailable", false);
                            this.set("canExecute", false);
                        }
                    }
                }

                //Remove command to edit approval sequence for Digizuite folders
                var origEAD = EditApprovalDefinition.prototype._setEnabledState;
                EditApprovalDefinition.prototype._setEnabledState = function () {
                    origEAD.apply(this, arguments);
                    if (this.model && this.model.capabilities.isDigizuiteElement) {
                        this.set("isAvailable", false);
                        this.set("canExecute", false);
                    }
                }

            }, _getRestPath: function (name) {
                return routes.getRestPath({ moduleArea: "digizuite", storeName: name });
            }

        });
    });